#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdint.h>

int
main()
{
	char buf[24];
	float c, frac, frac2;
	float x, y;
	uint32_t m, m2, mask;
	int e, e2, exp, exp2, i, k;

	x = 9e-01;
	
	for (i = 0; i < 47; i++) {

		c = cosf(x);
		y = 1.0f - c;
		y /= (x*x);
	
		printf("%d) y = %1.8e\n", i, y);
		printf("    x = %1.8e\n", x);
	
		frac = frexpf(1.0f, &exp);
		frac2 = frexpf(c, &exp2);
		e = ilogbf(1.0f);
		e2 = ilogbf(c);
	
		printf(" base 10: \n");
		printf("  1.0    = %1.9f\n", ldexpf(frac, exp));
		printf("  cos(x) = %1.9f\n", ldexpf(frac2, exp2));

		*((float *)&m) = 1.0f;
		*((float *)&m2) = c;
	
		printf(" base 2: \n");

		mask = 0x1;
		for (k = 0; k < 23; k++) {
			buf[22-k] = (m & mask ? '1' : '0');
			mask <<= 1;
		}
		buf[23] = '\0';
		printf("  1.0    = 1.%sx2^%d\n", buf, e);

		mask = 0x1;
		for (k = 0; k < 23; k++) {
			buf[22-k] = (m2 & mask ? '1' : '0');
			mask <<= 1;
		}
		buf[23] = '\0';
		printf("  cos(x) = 1.%sx2^%d\n", buf, e2);

		printf("\n");

		x /= 1.2;
	}

	return 0;
}

